/* clns.c - MIB realization of the experimental CLNS group */

#ifndef	lint
static char *rcsid = "$Header$";
#endif

/* 
 * $Header$
 *
 * Originally contributed by NYSERNet Inc.  This work was partially supported
 * by the U.S. Defense Advanced Research Projects Agency and the Rome Air
 * Development Center of the U.S. Air Force Systems Command under contract
 * number F30602-88-C-0016.
 *
 *
 * $Log$
 */

/*
 *			  ISODE 8.0 NOTICE
 *
 *   Acquisition, use, and distribution of this module and related
 *   materials are subject to the restrictions of a license agreement.
 *   Consult the Preface in the User's Manual for the full terms of
 *   this agreement.
 *
 *
 *			4BSD/ISODE SNMPv2 NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions given in the file
 *    SNMPv2-READ-ME.
 *
 */


#include <stdio.h>
#include "mib.h"
#include "interfaces.h"
#include "routes.h"

#ifdef	BSD44
#include <sys/kinfo.h>
#include <net/if_dl.h>
#include <netiso/iso_snpac.h>
#define	CLNP_ER_CODES
#include <netiso/clnp.h>
#include <netiso/clnp_stat.h>
#include <netiso/esis.h>

/*  */

#define	FORW_IS		1		/* clnpForwarding */
#define	FORW_ES		2
static	int	iso_systype;

struct clnp_stat clnp_stat;

/*  */

#define	clnpForwarding	0
#define	clnpDefaultLifeTime 1
#define	clnpInReceives	2
#define	clnpInHdrErrors	3
#define	clnpInAddrErrors 4
#define	clnpForwPDUs	5
#undef	clnpInUnknownNLPs /* 6		/* NOT IMPLEMENTED */
#define	clnpInUnknownULPs 7
#undef	clnpInDiscards	/* 8		/* NOT IMPLEMENTED */
#define	clnpInDelivers	9
#define	clnpOutRequests	10
#define	clnpOutDiscards	11
#define	clnpOutNoRoutes	12
#define	clnpReasmTimeout 13
#define	clnpReasmReqds	14
#define	clnpReasmOKs	15
#define	clnpReasmFails	16
#define	clnpSegOKs	17
#define	clnpSegFails	18
#define	clnpSegCreates	19
#undef	clnpInOpts	/* 20		/* NOT IMPLEMENTED */
#undef	clnpOutOpts	/* 21		/* NOT IMPLEMENTED */
#undef	clnpRoutingDiscards /* 22	/* NOT IMPLEMENTED */

#define	clnpInErrors	(100 + 0)
#define	clnpOutErrors	(100 + 1)
#define	clnpInErrUnspecs (100 + 2)
#define	clnpInErrProcs	(100 + 3)
#define	clnpInErrCksums	(100 + 4)
#define	clnpInErrCongests (100 + 5)
#define	clnpInErrHdrs	(100 + 6)
#define	clnpInErrSegs	(100 + 7)
#define	clnpInErrIncomps (100 + 8)
#define	clnpInErrDups	(100 + 9)
#define	clnpInErrUnreachDsts (100 + 10)
#define	clnpInErrUnknownDsts (100 + 11)
#define	clnpInErrSRUnspecs (100 + 12)
#define	clnpInErrSRSyntaxes (100 + 13)
#define	clnpInErrSRUnkAddrs (100 + 14)
#define	clnpInErrSRBadPaths (100 + 15)
#define	clnpInErrHops	(100 + 16)
#define	clnpInErrHopReassms (100 + 17)
#define	clnpInErrUnsOptions (100 + 18)
#define	clnpInErrUnsVersions (100 + 19)
#define	clnpInErrUnsSecurities (100 + 20)
#define	clnpInErrUnsSRs	(100 + 21)
#define	clnpInErrUnsRRs	(100 + 22)
#define	clnpInErrInterferences (100 + 23)
#define	clnpOutErrUnspecs	(100 + 24)
#define	clnpOutErrProcs	(100 + 25)
#define	clnpOutErrCksums (100 + 26)
#define	clnpOutErrCongests (100 + 27)
#define	clnpOutErrHdrs	(100 + 28)
#define	clnpOutErrSegs	(100 + 29)
#define	clnpOutErrIncomps (100 + 30)
#define	clnpOutErrDups	(100 + 31)
#define	clnpOutErrUnreachDsts (100 + 32)
#define	clnpOutErrUnknownDsts (100 + 33)
#define	clnpOutErrSRUnspecs (100 + 34)
#define	clnpOutErrSRSyntaxes (100 + 35)
#define	clnpOutErrSRUnkAddrs (100 + 36)
#define	clnpOutErrSRBadPaths (100 + 37)
#define	clnpOutErrHops	(100 + 38)
#define	clnpOutErrHopReassms (100 + 39)
#define	clnpOutErrUnsOptions (100 + 40)
#define	clnpOutErrUnsVersions (100 + 41)
#define	clnpOutErrUnsSecurities	(100 + 42)
#define	clnpOutErrUnsSRs (100 + 43)
#define	clnpOutErrUnsRRs (100 + 44)
#define	clnpOutErrInterferences	(100 + 45)


static int  o_clnp (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    register int   *dp,
		   *ep,
		    j;
    int	    ifvar;
    register struct clnp_stat *cns = &clnp_stat;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;
    static   int lastq = -1;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem != ot -> ot_name -> oid_nelem + 1
		    || oid -> oid_elements[oid -> oid_nelem - 1] != 0)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		OID	new;

		if ((new = oid_extend (oid, 1)) == NULLOID)
		    return NOTOK;
		new -> oid_elements[new -> oid_nelem - 1] = 0;

		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;
	    }
	    else
		return NOTOK;
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case clnpDefaultLifeTime:
	case clnpReasmTimeout:
	    break;
	    
	default:
	    if (quantum != lastq) {
		lastq = quantum;

		if (getkmem (nl + N_ISO_SYSTYPE, (caddr_t) &iso_systype,
			     sizeof iso_systype) == NOTOK
		        || getkmem (nl + N_CLNP_STAT, (caddr_t) cns,
				    sizeof *cns) == NOTOK)
		    return generr (offset);
	    }
	    break;
    }

    switch (ifvar) {
	case clnpForwarding:
	    return o_integer (oi, v,
			      iso_systype & SNPA_ES ? FORW_ES : FORW_IS);

	case clnpDefaultLifeTime:
	    return o_integer (oi, v, CLNP_TTL);

	case clnpInReceives:
	    return o_integer (oi, v, cns -> cns_total);

	case clnpInHdrErrors:
	    return o_integer (oi, v, cns -> cns_toosmall
			           + cns -> cns_badhlen
				   + cns -> cns_badcsum
			           + cns -> cns_noseg
				   + cns -> cns_badvers);

	case clnpInAddrErrors:
	    return o_integer (oi, v, cns -> cns_badaddr);

	case clnpForwPDUs:
	    return o_integer (oi, v, cns -> cns_forward);

	case clnpInUnknownULPs:
	    return o_integer (oi, v, cns -> cns_noproto);

	case clnpInDelivers:
	    return o_integer (oi, v, cns -> cns_delivered);

	case clnpOutRequests:
	    return o_integer (oi, v, cns -> cns_sent - cns -> cns_forward);

	case clnpOutDiscards:
	    return o_integer (oi, v, cns -> cns_odropped);

	case clnpOutNoRoutes:
	    return o_integer (oi, v, cns -> cns_cantforward);

	case clnpReasmTimeout:
	    return o_integer (oi, v, CLNP_TTL);

	case clnpReasmReqds:
	    return o_integer (oi, v, cns -> cns_fragments);

	case clnpReasmOKs:
	    return o_integer (oi, v, cns -> cns_reassembled);

	case clnpReasmFails:
	    return o_integer (oi, v, cns -> cns_fragdropped
				   + cns -> cns_fragtimeout);

	case clnpSegOKs:
	    return o_integer (oi, v, cns -> cns_fragmented);

	case clnpSegFails:
	    return o_integer (oi, v, cns -> cns_cantfrag);

	case clnpSegCreates:
	    return o_integer (oi, v, cns -> cns_ofragments);

	case clnpInErrors:
	    j = 0;
	    for (ep = (dp = cns -> cns_er_inhist) + CLNP_ERRORS; dp <= ep; )
		j += *dp++;
	    return o_integer (oi, v, j);

	case clnpOutErrors:
	    j = 0;
	    for (ep = (dp = cns -> cns_er_outhist) + CLNP_ERRORS; dp <= ep; )
		j += *dp++;
	    return o_integer (oi, v, j);

#define	clnpInputError(r)	cns -> cns_er_inhist[clnp_er_index (r)]

	case clnpInErrUnspecs:
	    return o_integer (oi, v, clnpInputError (GEN_NOREAS));

	case clnpInErrProcs:
	    return o_integer (oi, v, clnpInputError (GEN_PROTOERR));

	case clnpInErrCksums:
	    return o_integer (oi, v, clnpInputError (GEN_BADCSUM));

	case clnpInErrCongests:
	    return o_integer (oi, v, clnpInputError (GEN_CONGEST));

	case clnpInErrHdrs:
	    return o_integer (oi, v, clnpInputError (GEN_HDRSYNTAX));

	case clnpInErrSegs:
	    return o_integer (oi, v, clnpInputError (GEN_SEGNEEDED));

	case clnpInErrIncomps:
	    return o_integer (oi, v, clnpInputError (GEN_INCOMPLETE));

	case clnpInErrDups:
	    return o_integer (oi, v, clnpInputError (GEN_DUPOPT));

	case clnpInErrUnreachDsts:
	    return o_integer (oi, v, clnpInputError (ADDR_DESTUNREACH));

	case clnpInErrUnknownDsts:
	    return o_integer (oi, v, clnpInputError (ADDR_DESTUNKNOWN));

	case clnpInErrSRUnspecs:
	    return o_integer (oi, v, clnpInputError (SRCRT_UNSPECERR));

	case clnpInErrSRSyntaxes:
	    return o_integer (oi, v, clnpInputError (SRCRT_SYNTAX));

	case clnpInErrSRUnkAddrs:
	    return o_integer (oi, v, clnpInputError (SRCRT_UNKNOWNADDR));

	case clnpInErrSRBadPaths:
	    return o_integer (oi, v, clnpInputError (SRCRT_BADPATH));

	case clnpInErrHops:
	    return o_integer (oi, v, clnpInputError (TTL_EXPTRANSIT));

	case clnpInErrHopReassms:
	    return o_integer (oi, v, clnpInputError (TTL_EXPREASS));

	case clnpInErrUnsOptions:
	    return o_integer (oi, v, clnpInputError (DISC_UNSUPPOPT));

	case clnpInErrUnsVersions:
	    return o_integer (oi, v, clnpInputError (DISC_UNSUPPVERS));

	case clnpInErrUnsSecurities:
	    return o_integer (oi, v, clnpInputError (DISC_UNSUPPSECURE));

	case clnpInErrUnsSRs:
	    return o_integer (oi, v, clnpInputError (DISC_UNSUPPSRCRT));

	case clnpInErrUnsRRs:
	    return o_integer (oi, v, clnpInputError (DISC_UNSUPPRECRT));

	case clnpInErrInterferences:
	    return o_integer (oi, v, clnpInputError (REASS_INTERFERE));

#undef	clnpInputError
#define	clnpOutputError(r)	cns -> cns_er_outhist[clnp_er_index (r)]

	case clnpOutErrUnspecs:
	    return o_integer (oi, v, clnpOutputError (GEN_NOREAS));

	case clnpOutErrProcs:
	    return o_integer (oi, v, clnpOutputError (GEN_PROTOERR));

	case clnpOutErrCksums:
	    return o_integer (oi, v, clnpOutputError (GEN_BADCSUM));

	case clnpOutErrCongests:
	    return o_integer (oi, v, clnpOutputError (GEN_CONGEST));

	case clnpOutErrHdrs:
	    return o_integer (oi, v, clnpOutputError (GEN_HDRSYNTAX));

	case clnpOutErrSegs:
	    return o_integer (oi, v, clnpOutputError (GEN_SEGNEEDED));

	case clnpOutErrIncomps:
	    return o_integer (oi, v, clnpOutputError (GEN_INCOMPLETE));

	case clnpOutErrDups:
	    return o_integer (oi, v, clnpOutputError (GEN_DUPOPT));

	case clnpOutErrUnreachDsts:
	    return o_integer (oi, v, clnpOutputError (ADDR_DESTUNREACH));

	case clnpOutErrUnknownDsts:
	    return o_integer (oi, v, clnpOutputError (ADDR_DESTUNKNOWN));

	case clnpOutErrSRUnspecs:
	    return o_integer (oi, v, clnpOutputError (SRCRT_UNSPECERR));

	case clnpOutErrSRSyntaxes:
	    return o_integer (oi, v, clnpOutputError (SRCRT_SYNTAX));

	case clnpOutErrSRUnkAddrs:
	    return o_integer (oi, v, clnpOutputError (SRCRT_UNKNOWNADDR));

	case clnpOutErrSRBadPaths:
	    return o_integer (oi, v, clnpOutputError (SRCRT_BADPATH));

	case clnpOutErrHops:
	    return o_integer (oi, v, clnpOutputError (TTL_EXPTRANSIT));

	case clnpOutErrHopReassms:
	    return o_integer (oi, v, clnpOutputError (TTL_EXPREASS));

	case clnpOutErrUnsOptions:
	    return o_integer (oi, v, clnpOutputError (DISC_UNSUPPOPT));

	case clnpOutErrUnsVersions:
	    return o_integer (oi, v, clnpOutputError (DISC_UNSUPPVERS));

	case clnpOutErrUnsSecurities:
	    return o_integer (oi, v, clnpOutputError (DISC_UNSUPPSECURE));

	case clnpOutErrUnsSRs:
	    return o_integer (oi, v, clnpOutputError (DISC_UNSUPPSRCRT));

	case clnpOutErrUnsRRs:
	    return o_integer (oi, v, clnpOutputError (DISC_UNSUPPRECRT));

	case clnpOutErrInterferences:
	    return o_integer (oi, v, clnpOutputError (REASS_INTERFERE));

#undef	clnpOutputError

	default:
	    return int_SNMP_error__status_genErr;
    }
}

/*  */

static int  clnp_er_index (p)
u_char p;
{
    register u_char *cp = clnp_er_codes + CLNP_ERRORS;

    while (cp-- > clnp_er_codes)
	if (*cp == p)
	    return (cp - clnp_er_codes);

    return (CLNP_ERRORS + 1);
}

/*  */

static int  s_clnp (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    int	    ifvar;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;
    register OS	    os = ot -> ot_syntax;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_set__request:
	case type_SNMP_PDUs_commit:
	case type_SNMP_PDUs_rollback:
	    if (oid -> oid_nelem != ot -> ot_name -> oid_nelem + 1
		    || oid -> oid_elements[oid -> oid_nelem - 1] != 0)
		return int_SNMP_error__status_noSuchName;
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    if (os == NULLOS) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"no syntax defined for object \"%s\"", ot -> ot_text);

	return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case clnpForwarding:
	    break;

	case clnpDefaultLifeTime:
	    switch (offset) {
		case type_SNMP_PDUs_set__request:
		    if (ot -> ot_save)
			(*os -> os_free) (ot -> ot_save), ot -> ot_save = NULL;
		    if ((*os -> os_decode) (&ot -> ot_save, v -> value)
			        == NOTOK)
			return v -> value -> pe_errno;
		    if (*((integer *) ot -> ot_save) != CLNP_TTL)
			return int_SNMP_error__status_wrongValue;
		    break;

		case type_SNMP_PDUs_commit:
		case type_SNMP_PDUs_rollback:
		    if (ot -> ot_save)
			(*os -> os_free) (ot -> ot_save), ot -> ot_save = NULL;
		    break;
	    }
	    return int_SNMP_error__status_noError;

	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (offset) {
	case type_SNMP_PDUs_set__request:
	    if (ot -> ot_save)
		(*os -> os_free) (ot -> ot_save), ot -> ot_save = NULL;
	    if (getkmem (nl + N_ISO_SYSTYPE, (caddr_t) &iso_systype,
			 sizeof iso_systype) == NOTOK
		    || chekmem (nl + N_ISO_SYSTYPE) == NOTOK)
		return int_SNMP_error__status_genErr;
	    if ((*os -> os_decode) (&ot -> ot_save, v -> value) == NOTOK)
		return v -> value -> pe_errno;
	    switch (*((integer *) ot -> ot_save)) {
		case FORW_IS:
		    iso_systype &= ~SNPA_ES;
		    break;

		case FORW_ES:
		    iso_systype |= SNPA_ES;
		    break;

		default:
		    return int_SNMP_error__status_wrongValue;
	    }
	    break;

	case type_SNMP_PDUs_commit:
	    if (setkmem (nl + N_ISO_SYSTYPE, (caddr_t) &iso_systype,
			 sizeof iso_systype) == NOTOK)
		return int_SNMP_error__status_genErr;
	    /* and fall */

	case type_SNMP_PDUs_rollback:
	    if (ot -> ot_save)
		(*os -> os_free) (ot -> ot_save), ot -> ot_save = NULL;
	    break;
    }

    return int_SNMP_error__status_noError;
}

/*  */

#define	CLNP_MAXPACKET	65535		/* clnpAdEntReasmMaxSize */
					/* equivalent of IP_MAXPACKET */


#define	clnpAdEntAddr	0
#define	clnpAdEntIfIndex 1
#define	clnpAdEntReasmMaxSize 2


static int  o_clnp_addr (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    register int   i;
    int	    ifvar;
    register unsigned int *ip,
			  *jp;
    register struct address   *as;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;

    if (get_interfaces (offset) == NOTOK)
	return generr (offset);

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem <= ot -> ot_name -> oid_nelem)
		return int_SNMP_error__status_noSuchName;
	    if ((as = get_addrent (oid -> oid_elements
				   	+ ot -> ot_name -> oid_nelem,
				   oid -> oid_nelem
				   	- ot -> ot_name -> oid_nelem,
				   afs_iso, 0)) == NULL)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem < ot -> ot_name -> oid_nelem)
		return NOTOK;
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		OID	new;

		if ((as = afs_iso) == NULL)
		    return NOTOK;

		if ((new = oid_extend (oid, as -> adr_insize)) == NULLOID)
		    return NOTOK;
		ip = new -> oid_elements + new -> oid_nelem - as -> adr_insize;
		jp = as -> adr_instance;
		for (i = as -> adr_insize; i > 0; i--)
		    *ip++ = *jp++;
		
		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;
	    }
	    else {
		int	j;
		
		if ((as = get_addrent (oid -> oid_elements
				           + ot -> ot_name -> oid_nelem,
				       j = oid -> oid_nelem
				               - ot -> ot_name -> oid_nelem,
				       afs_iso, 1)) == NULL)
		    return NOTOK;

		if ((i = j - as -> adr_insize) < 0) {
		    OID	    new;

		    if ((new = oid_extend (oid, -i)) == NULLOID)
			return NOTOK;
		    if (v -> name)
			free_SNMP_ObjectName (v -> name);
		    v -> name = new;

		    oid = new;
		}
		else
		    if (i > 0)
			oid -> oid_nelem -= i;

		ip = oid -> oid_elements + ot -> ot_name -> oid_nelem;
		jp = as -> adr_instance;
		for (i = as -> adr_insize; i > 0; i--)
		    *ip++ = *jp++;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case clnpAdEntAddr:
	    return o_clnpaddr (oi, v,
			       (struct sockaddr_iso *) &as -> adr_address);

	case clnpAdEntIfIndex:
	    return o_integer (oi, v, ffs (as -> adr_indexmask));

	case clnpAdEntReasmMaxSize:
	    return o_integer (oi, v, CLNP_MAXPACKET);

	default:
	    return int_SNMP_error__status_genErr;
    }
}

/*  */

#define	clnpRouteDest	0
#define	clnpRouteIfIndex 1
#define	clnpRouteMetric1 2
#define	clnpRouteMetric2 3
#define	clnpRouteMetric3 4
#define	clnpRouteMetric4 5
#define	clnpRouteNextHop 6
#define	clnpRouteType	7
#define	clnpRouteProto	8
#define	clnpRouteAge	9
#define	clnpRouteMetric5 10
#define	clnpRouteInfo	11
#define	unixClnpRouteFlags 12
#define	unixClnpRouteRefCnt 13
#define	unixClnpRouteUses 14


static int  o_clnp_route (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    int	    ifvar;
    register int    i;
    register unsigned int *ip,
			  *jp;
    register struct rtetab *rt;
    register OID    oid = oi -> oi_name;
    OID	    new;
    register OT	    ot = oi -> oi_type;

    if (get_routes (offset) == NOTOK)
	return generr (offset);

    ifvar = (int) ot -> ot_info;
try_again: ;
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem <= ot -> ot_name -> oid_nelem)
		return int_SNMP_error__status_noSuchName;
	    if ((rt = get_rtent (oid -> oid_elements
				     + ot -> ot_name -> oid_nelem,
				 oid -> oid_nelem
				     - ot -> ot_name -> oid_nelem,
				 rts_iso, 0)) == NULL)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		if ((rt = rts_iso) == NULL)
		    return NOTOK;

		if ((new = oid_extend (oid, rt -> rt_insize)) == NULLOID)
		    return NOTOK;
		ip = new -> oid_elements + new -> oid_nelem - rt -> rt_insize;
		jp = rt -> rt_instance;
		for (i = rt -> rt_insize; i > 0; i--)
		    *ip++ = *jp++;
		
		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;

		oid = new;	/* for try_again... */
	    }
	    else {
		int	j;

		if ((rt = get_rtent (oid -> oid_elements
				         + ot -> ot_name -> oid_nelem,
				     j = oid -> oid_nelem
				             - ot -> ot_name -> oid_nelem,
				     rts_iso, 1)) == NULL)
		    return NOTOK;

		if ((i = j - rt -> rt_insize) < 0) {
		    if ((new = oid_extend (oid, -i)) == NULLOID)
			return NOTOK;
		    if (v -> name)
			free_SNMP_ObjectName (v -> name);
		    v -> name = new;

		    oid = new;
		}
		else
		    if (i > 0)
			oid -> oid_nelem -= i;

		ip = oid -> oid_elements + ot -> ot_name -> oid_nelem;
		jp = rt -> rt_instance;
		for (i = rt -> rt_insize; i > 0; i--)
		    *ip++ = *jp++;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case clnpRouteDest:
	    return o_clnpaddr (oi, v,
			     (struct sockaddr_iso *) &rt -> rt_dst);

	case clnpRouteIfIndex:
	    {
		register struct interface *is;

		for (is = ifs; is; is = is -> ifn_next)
		    if ((caddr_t) is -> ifn_offset
			        == (caddr_t) rt -> rt_rt.rt_ifp) {
			if (is -> ifn_ready)
			    return o_integer (oi, v, is -> ifn_index);
			break;
		    }

		if (offset == type_SNMP_PDUs_get__next__request)
		    goto try_again;
		return int_SNMP_error__status_noSuchName;
	    }
	    
	case clnpRouteMetric1:
	case clnpRouteMetric2:
	case clnpRouteMetric3:
	case clnpRouteMetric4:
	case clnpRouteMetric5:
	    return o_integer (oi, v, METRIC_NONE);

	case clnpRouteNextHop:
	    return o_clnpaddr (oi, v,
			       (struct sockaddr_iso *) &rt -> rt_gateway);

	case clnpRouteType:
	    return o_integer (oi, v, rt -> rt_type);

	case clnpRouteProto:
	    if (rt -> rt_rt.rt_flags & (RTF_DYNAMIC | RTF_MODIFIED))
		return o_integer (oi, v, PROTO_ESIS);
	    else
		return o_integer (oi, v, PROTO_OTHER);

	case clnpRouteAge:
	    return o_integer (oi, v, 0);

	case clnpRouteInfo:
	    return o_specific (oi, v, (caddr_t) nullSpecific);

	case unixClnpRouteFlags:
	    return o_integer (oi, v, rt -> rt_rt.rt_flags & 0xffff);

	case unixClnpRouteRefCnt:
	    return o_integer (oi, v, rt -> rt_rt.rt_refcnt & 0xffff);

	case unixClnpRouteUses:
	    return o_integer (oi, v, rt -> rt_rt.rt_use);

	default:
	    return int_SNMP_error__status_genErr;
    }
}

/*  */

struct adrtab {
#define	ADN_SIZE	ADR_SIZE		/* NsapAddress instance */
    unsigned int    adn_instance[ADN_SIZE];	
    int	    adn_insize;				

    struct iso_addr adn_address;		/* NsapAddress */


#define	ADM_SIZE	ADR_SIZE		/* PhysAddress instance */
    unsigned int    adm_instance[ADM_SIZE];	
    int	    adm_insize;				

    u_char	adm_address[ADM_SIZE];		/* PhysAddress */
    u_char	adm_addrlen;			/*   .. */


    int	    adr_index;				/* ifIndex */

    int	    adr_type;				/* clnpNetToMediaType */
						/* clnpMediaToNetType */
#define	DYNAMIC_MAPPING	3
#define	STATIC_MAPPING	4


    struct adrtab *adn_next;			/* next NsapAddress */
    struct adrtab *adm_next;    		/* next PhysAddress */
};

static	struct adrtab *adn = NULL;
static	struct adrtab *adm = NULL;

static	int	flush_arp_cache = 0;


static struct adrtab *get_arpent ();

/*  */

#define	clnpNetToMediaIfIndex 0
#define	clnpNetToMediaPhysAddress 1
#define	clnpNetToMediaNetAddress 2
#define	clnpNetToMediaType 3
#undef	clnpNetToMediaAge /* 4		/* NOT IMPLEMENTED */
#undef	clnpNetToMediaHoldTime /* 5	/* NOT IMPLEMENTED */

#define	clnpMediaToNetIfIndex 6
#define	clnpMediaToNetAddress 7
#define	clnpMediaToNetPhysAddress 8
#define	clnpMediaToNetType 9
#undef	clnpMediaToNetAge /* 10		/* NOT IMPLEMENTED */
#undef	clnpMediaToNetHoldTime /* 11	/* NOT IMPLEMENTED */


static int  o_address (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    register int    i;
    int	    ifvar,
	    isnpa;
    register unsigned int *ip,
			  *jp;
    register struct adrtab *at;
    struct sockaddr_iso netaddr;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;

    if (get_arptab (offset) == NOTOK)
	return generr (offset);

    switch (ifvar = (int) ot -> ot_info) {
	case clnpNetToMediaIfIndex:
	case clnpNetToMediaPhysAddress:
	case clnpNetToMediaNetAddress:
	case clnpNetToMediaType:
	    isnpa = 0;
	    break;

	case clnpMediaToNetIfIndex:
	case clnpMediaToNetAddress:
	case clnpMediaToNetPhysAddress:
	case clnpMediaToNetType:
	    isnpa = 1;
	    break;

	default:
	    return generr (offset);
    }
    
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem <= ot -> ot_name -> oid_nelem)
		return int_SNMP_error__status_noSuchName;
	    if ((at = get_arpent (oid -> oid_elements
				  	+ ot -> ot_name -> oid_nelem,
				  oid -> oid_nelem
				  	- ot -> ot_name -> oid_nelem,
				  isnpa, 0)) == NULL)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem < ot -> ot_name -> oid_nelem)
		return NOTOK;
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		OID	new;

		if ((at = isnpa ? adm : adn) == NULL)
		    return NOTOK;
		if (isnpa)
		    jp = at -> adm_instance, i = at -> adm_insize;
		else
		    jp = at -> adn_instance, i = at -> adn_insize;

		if ((new = oid_extend (oid, i)) == NULLOID)
		    return NOTOK;
		ip = new -> oid_elements + new -> oid_nelem - i;
		for (; i > 0; i--)
		    *ip++ = *jp++;

		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;
	    }
	    else {
		int	j;

		if ((at = get_arpent (oid -> oid_elements
				          + ot -> ot_name -> oid_nelem,
				      j = oid -> oid_nelem
				      	      - ot -> ot_name -> oid_nelem,
				      isnpa, 1)) == NULL)
		    return NOTOK;
		i = isnpa ? at -> adm_insize : at -> adn_insize;

		if ((i = j - i) < 0) {
		    OID	    new;

		    if ((new = oid_extend (oid, -i)) == NULLOID)
			return NOTOK;
		    if (v -> name)
			free_SNMP_ObjectName (v -> name);
		    v -> name = new;

		    oid = new;
		}
		else
		    if (i > 0)
			oid -> oid_nelem -= i;

		ip = oid -> oid_elements + ot -> ot_name -> oid_nelem;
		if (isnpa)
		    jp = at -> adm_instance, i = at -> adm_insize;
		else
		    jp = at -> adn_instance, i = at -> adn_insize;
		for (; i > 0; i--)
		    *ip++ = *jp++;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case clnpNetToMediaIfIndex:
	case clnpMediaToNetIfIndex:
	    return o_integer (oi, v, at -> adr_index);

	case clnpNetToMediaPhysAddress:
	case clnpMediaToNetPhysAddress:
	    return o_string (oi, v, (char *) at -> adm_address,
			     (int) at -> adm_addrlen);

	case clnpNetToMediaNetAddress:
	case clnpMediaToNetAddress:
	    netaddr.siso_addr = at -> adn_address;	/* struct copy */
	    return o_clnpaddr (oi, v, &netaddr);

	case clnpNetToMediaType:
	case clnpMediaToNetType:
	    return o_integer (oi, v, at -> adr_type);

	default:
	    return int_SNMP_error__status_genErr;
    }
}

/*  */

static int  adn_compar (a, b)
register struct adrtab **a,
		       **b;
{
    return elem_cmp ((*a) -> adn_instance, (*a) -> adn_insize,
		     (*b) -> adn_instance, (*b) -> adn_insize);
}


static int  adm_compar (a, b)
register struct adrtab **a,
		       **b;
{
    return elem_cmp ((*a) -> adm_instance, (*a) -> adm_insize,
		     (*b) -> adm_instance, (*b) -> adm_insize);
}


#define	ROUND(a)	(1 + (((a) - 1) | (sizeof (long) - 1)))

static int  get_arptab (offset)
int	offset;
{
    int	    adrNumber = 0,
	    rlen,
	    tblsize;
    char   *snpac;
    register char *sc,
		  *se;
    register struct adrtab *at,
			   *ap,
			  **base,
			  **afe,
			  **afp;
    register struct interface *is;
    register struct rt_msghdr *rtm;
    static  int first_time = 1;
    static  int lastq = -1;

    if (quantum == lastq)
	return OK;
    if (!flush_arp_cache
	    && offset == type_SNMP_PDUs_get__next__request
	    && quantum == lastq + 1) {			/* XXX: caching! */
	lastq = quantum;
	return OK;
    }
    lastq = quantum, flush_arp_cache = 0;

    for (at = adn; at; at = ap) {
	ap = at -> adn_next;

	free ((char *) at);
    }
    adn = adm = NULL;

    if ((tblsize = getkerninfo (KINFO_RT_DUMP, NULLCP, NULLIP, 0)) == NOTOK)
	return NOTOK;
    if ((snpac = malloc ((unsigned) tblsize)) == NULL)
	adios (NULLCP, "out of memory");
    if ((rlen = getkerninfo (KINFO_RT_DUMP, snpac, &tblsize, 0)) == NOTOK) {
	free (snpac);
	return NOTOK;
    }

    afp = &adn;
    for (se = (sc = snpac) + rlen; sc < se; sc += rtm -> rtm_msglen) {
	register struct sockaddr_dl *sdl;
	register struct sockaddr *sa;
	struct iso_addr nsap;

	rtm = (struct rt_msghdr *) sc;
	sa = (struct sockaddr *) (rtm + 1);
	if (sa -> sa_family != AF_ISO)
	    continue;

	sdl = (struct sockaddr_dl *) (((caddr_t) sa) + ROUND (sa -> sa_len));
	if (sdl -> sdl_family != AF_LINK)
	    continue;

	nsap = ((struct sockaddr_iso *) sa) -> siso_addr;    /* struct copy */
	if (nsap.isoa_len == 0)
	    continue;

	for (is = ifs; is; is = is -> ifn_next)
	    if (is -> ifn_interface.ac_if.if_index == rtm -> rtm_index)
		break;
	if (!is) {
	    if (first_time)
		advise (LLOG_EXCEPTIONS, NULLCP,
			"unable to find interface for SNPA in cache");
	    continue;
	}

	if ((at = (struct adrtab *) calloc (1, sizeof *at)) == NULL)
	    adios (NULLCP, "out of memory");
	*afp = at, afp = &at -> adn_next, adrNumber++;

	at -> adr_index = is -> ifn_index;
	at -> adr_type = rtm -> rtm_flags & RTF_DYNAMIC
				? DYNAMIC_MAPPING : STATIC_MAPPING;

	at -> adn_address = nsap;	/* struct copy */
	at -> adn_instance[0] = at -> adr_index, at -> adn_insize = 1;
	at -> adn_insize += clnpaddr2oid (at -> adn_instance + 1,
					  &at -> adn_address);

	bcopy ((char *) LLADDR (sdl), (char *) at -> adm_address,
	       (int) (at -> adm_addrlen = sdl -> sdl_alen));
	at -> adm_instance[0] = at -> adr_index, at -> adm_insize = 1;
	at -> adm_insize += mediaddr2oid (at -> adm_instance + 1,
					  at -> adm_address,
					  (int) at -> adm_addrlen, 0);

	if (debug && first_time) {
	    char    buffer[BUFSIZ];
	    OIDentifier	oids;

	    oids.oid_elements = at -> adn_instance + 1;
	    oids.oid_nelem = at -> adn_insize - 1;
	    (void) strcpy (buffer, sprintoid (&oids));
	    oids.oid_elements = at -> adm_instance;
	    oids.oid_nelem = at -> adm_insize;
	    advise (LLOG_DEBUG, NULLCP,
		    "add mapping on interface %d: %s -> %s",
		    at -> adr_index, buffer, sprintoid (&oids));
	}
    }
    first_time = 0;
    free ((char *) snpac);

    if (adrNumber <= 1) {
	adm = adn;
	return OK;
    }

    if ((base = (struct adrtab **)
		    malloc ((unsigned) (adrNumber * sizeof *base))) == NULL)
	adios (NULLCP, "out of memory");

    afe = base;
    for (at = adn; at; at = at -> adn_next)
	*afe++ = at;

    qsort ((char *) base, adrNumber, sizeof *base, adn_compar);

    afp = base;
    at = adn = *afp++;
    while (afp < afe) {
	at -> adn_next = *afp;
	at = *afp++;
    }
    at -> adn_next = NULL;

    qsort ((char *) base, adrNumber, sizeof *base, adm_compar);

    afp = base;
    at = adm = *afp++;
    while (afp < afe) {
	at -> adm_next = *afp;
	at = *afp++;
    }
    at -> adm_next = NULL;

    free ((char *) base);

    return OK;
}
#undef	ROUND

/*  */

static struct adrtab *get_arpent (ip, len, isnpa, isnext)
register unsigned int *ip;
int	len;
int	isnpa,
	isnext;
{
    register struct adrtab *at;

    if (isnpa)
	for (at = adm; at; at = at -> adm_next)
	    switch (elem_cmp (at -> adm_instance, at -> adm_insize, ip, len)) {
		case 0:
		    if (!isnext)
			return at;
		    if ((at = at -> adm_next) == NULL)
			goto out;
		    /* else fall... */

		case 1:
		    return (isnext ? at : NULL);
	    }
    else
	for (at = adn; at; at = at -> adn_next)
	    switch (elem_cmp (at -> adn_instance, at -> adn_insize, ip, len)) {
		case 0:
		    if (!isnext)
			return at;
		    if ((at = at -> adn_next) == NULL)
			goto out;
		    /* else fall... */

		case 1:
		    return (isnext ? at : NULL);
	    }

out: ;
    flush_arp_cache = 1;

    return NULL;
}

/*  */

static	struct esis_stat esis_stat;

/*  */

#define	esisESHins	0
#define	esisESHouts	1
#define	esisISHins	2
#define	esisISHouts	3
#define	esisRDUins	4
#define	esisRDUouts	5


static int  o_esis (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    int	    ifvar;
    register struct esis_stat *es = &esis_stat;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;
    static   int lastq = -1;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem != ot -> ot_name -> oid_nelem + 1
		    || oid -> oid_elements[oid -> oid_nelem - 1] != 0)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		OID	new;

		if ((new = oid_extend (oid, 1)) == NULLOID)
		    return NOTOK;
		new -> oid_elements[new -> oid_nelem - 1] = 0;

		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;
	    }
	    else
		return NOTOK;
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    if (quantum != lastq) {
	lastq = quantum;

	if (getkmem (nl + N_ESIS_STAT, (caddr_t) &esis_stat, sizeof esis_stat)
	        == NOTOK)
	    return generr (offset);
    }

    switch (ifvar) {
	case esisESHins:
	    return o_integer (oi, v, es -> es_eshrcvd);

	case esisESHouts:
	    return o_integer (oi, v, es -> es_eshsent);

	case esisISHins:
	    return o_integer (oi, v, es -> es_ishrcvd);

	case esisISHouts:
	    return o_integer (oi, v, es -> es_ishsent);

	case esisRDUins:
	    return o_integer (oi, v, es -> es_rdrcvd);

	case esisRDUouts:
	    return o_integer (oi, v, es -> es_rdsent);

	default:
	    return int_SNMP_error__status_genErr;
    }
}

/*  */

static struct objreg clnp_objects[] = {
    "clnpForwarding",		(caddr_t) clnpForwarding,
    "clnpDefaultLifeTime",	(caddr_t) clnpDefaultLifeTime,
    "clnpInReceives",		(caddr_t) clnpInReceives,
    "clnpInHdrErrors",		(caddr_t) clnpInHdrErrors,
    "clnpInAddrErrors",		(caddr_t) clnpInAddrErrors,
    "clnpForwPDUs",		(caddr_t) clnpForwPDUs,
#ifdef	clnpInUnknownNLPs
    "clnpInUnknownNLPs",	(caddr_t) clnpInUnknownNLPs,
#endif
    "clnpInUnknownULPs",	(caddr_t) clnpInUnknownULPs,
#ifdef	clnpInDiscards
    "clnpInDiscards",		(caddr_t) clnpInDiscards,
#endif
    "clnpInDelivers",		(caddr_t) clnpInDelivers,
    "clnpOutRequests",		(caddr_t) clnpOutRequests,
    "clnpOutDiscards",		(caddr_t) clnpOutDiscards,
    "clnpOutNoRoutes",		(caddr_t) clnpOutNoRoutes,
    "clnpReasmTimeout",		(caddr_t) clnpReasmTimeout,
    "clnpReasmReqds",		(caddr_t) clnpReasmReqds,
    "clnpReasmOKs",		(caddr_t) clnpReasmOKs,
    "clnpReasmFails",		(caddr_t) clnpReasmFails,
    "clnpSegOKs",		(caddr_t) clnpSegOKs,
    "clnpSegFails",		(caddr_t) clnpSegFails,
    "clnpSegCreates",		(caddr_t) clnpSegCreates,
#ifdef	clnpInOpts
    "clnpInOpts",		(caddr_t) clnpInOpts,
#endif
#ifdef	clnpOutOpts
    "clnpOutOpts",		(caddr_t) clnpOutOpts,
#endif
#ifdef	clnpRoutingDiscards
    "clnpRoutingDiscards",	(caddr_t) clnpRoutingDiscards,
#endif

    "clnpInErrors",		(caddr_t) clnpInErrors,
    "clnpOutErrors",		(caddr_t) clnpOutErrors,
    "clnpInErrUnspecs",		(caddr_t) clnpInErrUnspecs,
    "clnpInErrProcs",		(caddr_t) clnpInErrProcs,
    "clnpInErrCksums",		(caddr_t) clnpInErrCksums,
    "clnpInErrCongests",	(caddr_t) clnpInErrCongests,
    "clnpInErrHdrs",		(caddr_t) clnpInErrHdrs,
    "clnpInErrSegs",		(caddr_t) clnpInErrSegs,
    "clnpInErrIncomps",		(caddr_t) clnpInErrIncomps,
    "clnpInErrDups",		(caddr_t) clnpInErrDups,
    "clnpInErrUnreachDsts",	(caddr_t) clnpInErrUnreachDsts,
    "clnpInErrUnknownDsts",	(caddr_t) clnpInErrUnknownDsts,
    "clnpInErrSRUnspecs",	(caddr_t) clnpInErrSRUnspecs,
    "clnpInErrSRSyntaxes",	(caddr_t) clnpInErrSRSyntaxes,
    "clnpInErrSRUnkAddrs",	(caddr_t) clnpInErrSRUnkAddrs,
    "clnpInErrSRBadPaths",	(caddr_t) clnpInErrSRBadPaths,
    "clnpInErrHops",		(caddr_t) clnpInErrHops,
    "clnpInErrHopReassms",	(caddr_t) clnpInErrHopReassms,
    "clnpInErrUnsOptions",	(caddr_t) clnpInErrUnsOptions,
    "clnpInErrUnsVersions",	(caddr_t) clnpInErrUnsVersions,
    "clnpInErrUnsSecurities",	(caddr_t) clnpInErrUnsSecurities,
    "clnpInErrUnsSRs",		(caddr_t) clnpInErrUnsSRs,
    "clnpInErrUnsRRs",		(caddr_t) clnpInErrUnsRRs,
    "clnpInErrInterferences",	(caddr_t) clnpInErrInterferences,
    "clnpOutErrUnspecs",	(caddr_t) clnpOutErrUnspecs,
    "clnpOutErrProcs",		(caddr_t) clnpOutErrProcs,
    "clnpOutErrCksums",		(caddr_t) clnpOutErrCksums,
    "clnpOutErrCongests",	(caddr_t) clnpOutErrCongests,
    "clnpOutErrHdrs",		(caddr_t) clnpOutErrHdrs,
    "clnpOutErrSegs",		(caddr_t) clnpOutErrSegs,
    "clnpOutErrIncomps",	(caddr_t) clnpOutErrIncomps,
    "clnpOutErrDups",		(caddr_t) clnpOutErrDups,
    "clnpOutErrUnreachDsts",	(caddr_t) clnpOutErrUnreachDsts,
    "clnpOutErrUnknownDsts",	(caddr_t) clnpOutErrUnknownDsts,
    "clnpOutErrSRUnspecs",	(caddr_t) clnpOutErrSRUnspecs,
    "clnpOutErrSRSyntaxes",	(caddr_t) clnpOutErrSRSyntaxes,
    "clnpOutErrSRUnkAddrs",	(caddr_t) clnpOutErrSRUnkAddrs,
    "clnpOutErrSRBadPaths",	(caddr_t) clnpOutErrSRBadPaths,
    "clnpOutErrHops",		(caddr_t) clnpOutErrHops,
    "clnpOutErrHopReassms",	(caddr_t) clnpOutErrHopReassms,
    "clnpOutErrUnsOptions",	(caddr_t) clnpOutErrUnsOptions,
    "clnpOutErrUnsVersions",	(caddr_t) clnpOutErrUnsVersions,
    "clnpOutErrUnsSecurities",	(caddr_t) clnpOutErrUnsSecurities,
    "clnpOutErrUnsSRs",		(caddr_t) clnpOutErrUnsSRs,
    "clnpOutErrUnsRRs",		(caddr_t) clnpOutErrUnsRRs,
    "clnpOutErrInterferences",	(caddr_t) clnpOutErrInterferences,

    NULL
};

static struct objreg clnp_addr_objects[] = {
    "clnpAdEntAddr",		(caddr_t) clnpAdEntAddr,
    "clnpAdEntIfIndex",		(caddr_t) clnpAdEntIfIndex,
    "clnpAdEntReasmMaxSize",	(caddr_t) clnpAdEntReasmMaxSize,

    NULL
};

static struct objreg clnp_route_objects[] = {
    "clnpRouteDest",		(caddr_t) clnpRouteDest,
    "clnpRouteIfIndex",		(caddr_t) clnpRouteIfIndex,
    "clnpRouteMetric1",		(caddr_t) clnpRouteMetric1,
    "clnpRouteMetric2",		(caddr_t) clnpRouteMetric2,
    "clnpRouteMetric3",		(caddr_t) clnpRouteMetric3,
    "clnpRouteMetric4",		(caddr_t) clnpRouteMetric4,
    "clnpRouteNextHop",		(caddr_t) clnpRouteNextHop,
    "clnpRouteType",		(caddr_t) clnpRouteType,
    "clnpRouteProto",		(caddr_t) clnpRouteProto,
    "clnpRouteAge",		(caddr_t) clnpRouteAge,

    "unixClnpRouteFlags",	(caddr_t) unixClnpRouteFlags,
    "unixClnpRouteRefCnt",	(caddr_t) unixClnpRouteRefCnt,
    "unixClnpRouteUses",	(caddr_t) unixClnpRouteUses,

    NULL
};

static struct objreg address_objects[] = {
    "clnpNetToMediaIfIndex",	(caddr_t) clnpNetToMediaIfIndex,
    "clnpNetToMediaPhysAddress",(caddr_t) clnpNetToMediaPhysAddress,
    "clnpNetToMediaNetAddress",	(caddr_t) clnpNetToMediaNetAddress,
    "clnpNetToMediaType",	(caddr_t) clnpNetToMediaType,
#ifdef	clnpNetToMediaAge
    "clnpNetToMediaAge",	(caddr_t) clnpNetToMediaAge,
#endif
#ifdef	clnpNetToMediaHoldTime
    "clnpNetToMediaHoldTime",	(caddr_t) clnpNetToMediaHoldTime,
#endif
    "clnpMediaToNetIfIndex",	(caddr_t) clnpMediaToNetIfIndex,
    "clnpMediaToNetAddress",	(caddr_t) clnpMediaToNetAddress,
    "clnpMediaToNetPhysAddress",(caddr_t) clnpMediaToNetPhysAddress,
    "clnpMediaToNetType",	(caddr_t) clnpMediaToNetType,
#ifdef	clnpMediaToNetAge
    "clnpMediaToNetAge",	(caddr_t) clnpMediaToNetAge,
#endif
#ifdef	clnpMediaToNetHoldTime
    "clnpMediaToNetHoldTime",	(caddr_t) clnpMediaToNetHoldTime,
#endif

    NULL
};

static struct objreg esis_objects[] = {
    "esisESHins",		(caddr_t) esisESHins,
    "esisESHouts",		(caddr_t) esisESHouts,
    "esisISHins",		(caddr_t) esisISHins,
    "esisISHouts",		(caddr_t) esisISHouts,
    "esisRDUins",		(caddr_t) esisRDUins,
    "esisRDUouts",		(caddr_t) esisRDUouts,

    NULL
};

init_clns () {
    register OT	    ot;

    if (nl[N_ISO_SYSTYPE].n_value == 0)
	return;

    register_objects (clnp_objects, o_clnp, NULLIFP);
    if (ot = text2obj ("clnpForwarding"))
	ot -> ot_setfnx = s_clnp;
    if (ot = text2obj ("clnpDefaultLifeTime"))
	ot -> ot_setfnx = s_clnp;

    register_objects (clnp_addr_objects, o_clnp_addr, NULLIFP);

    register_objects (clnp_route_objects, o_clnp_route, NULLIFP);

    register_objects (address_objects, o_address, NULLIFP);

    register_objects (esis_objects, o_esis, NULLIFP);
}
#else

init_clns () {}

#endif
