/* mib.h - MIB realization */

/* 
 * $Header$
 *
 * Originally contributed by NYSERNet Inc.  This work was partially supported
 * by the U.S. Defense Advanced Research Projects Agency and the Rome Air
 * Development Center of the U.S. Air Force Systems Command under contract
 * number F30602-88-C-0016.
 *
 *
 * $Log$
 */

/*
 *			  ISODE 8.0 NOTICE
 *
 *   Acquisition, use, and distribution of this module and related
 *   materials are subject to the restrictions of a license agreement.
 *   Consult the Preface in the User's Manual for the full terms of
 *   this agreement.
 *
 *
 *			4BSD/ISODE SNMPv2 NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions given in the file
 *    SNMPv2-READ-ME.
 *
 */


#include <nlist.h>
#ifdef	__NeXT__
#define	n_name	n_un.n_name
#endif
#include "SNMP-types.h"
#include "objects.h"
#include "logger.h"


#define	generr(offset)	((offset) == type_SNMP_PDUs_get__next__request \
				    ? NOTOK : int_SNMP_error__status_genErr)

/*  */

#define	sysDescr	"4BSD/ISODE SNMPv2"

#ifdef	BSD44
#define	sysObjectID	"1.3.6.1.4.1.4.1.2.9.4"	/* 4.4BSD/OSI */
#else /* not 4.4BSD */


#ifdef	SUNOS4

#ifdef	SUNOS41
#define	sysObjectID	"1.3.6.1.4.1.4.1.2.9.6"	/* SunOS 4.1 */
#else	/* not SunOS 4.1 */
#define	sysObjectID	"1.3.6.1.4.1.4.1.2.9.5"	/* SunOS 4.0 */
#endif

#else	/* not 4.4BSD or SunOS 4.x */

#ifdef	BSD43

#ifdef	BSD43_Tahoe
#define	sysObjectID	"1.3.6.1.4.1.4.1.2.9.3"	/* 4.3BSD tahoe */
#else	/* 4.3BSD but not tahoe */
#define	sysObjectID	"1.3.6.1.4.1.4.1.2.9.2"	/* 4.3BSD */
#endif

#else	/* not 4.4BSD or SunOS 4.x or 4.3BSD */

#define	sysObjectID	"1.3.6.1.4.1.4.1.2.9.1"	/* generic 4.2BSD */

#endif

#endif
#endif

/*  */

extern struct nlist nl[];
#define	N_ARPTAB	0
#define	N_ARPTAB_SIZE	1
#define	N_ICMPSTAT	2
#define	N_IFNET		3
#define	N_IPFORWARDING	4
#define	N_IPSTAT	5
#define	N_RTHASHSIZE	6
#define	N_RTHOST	7
#define	N_RTNET		8
#define	N_TCB		9
#define	N_TCPSTAT	10
#define	N_UDB		11
#define	N_UDPSTAT	12
#define	N_RTSTAT	13
#define	N_MBSTAT	14
#define	N_NFILE		15
#define	N_FILE		16
#ifdef	BSD44
#define	N_RADIX_NODE_HEAD 17
#define	N_ISO_SYSTYPE	18
#define	N_CLNP_STAT	19
#define	N_ESIS_STAT	20
#endif


int	init_mib (), fin_mib (), set_variable ();
int	getkmem (), setkmem (), chekmem ();

/*  */

extern  int	nd;

struct checklist {
    IFP	    ck_fnx;
    caddr_t ck_info;

    int	    ck_idx;

    struct checklist *ck_next;
};

extern struct checklist *ckHead;


#define	MAGIC

#ifdef	MAGIC
#define	MAGIC_NONE		0
#define	MAGIC_LEXIBROKEN	1
#define	MAGIC_CELLMISSING	2
#define	MAGIC_NEWROW		3
#define	MAGIC_LONGROW		4
#define	MAGIC_WRONGTAG		5
#define	MAGIC_NOTMINLEN		6
#define	MAGIC_TOOSMALLINT	7
#define	MAGIC_TOOBIGINT		8
#define	MAGIC_NOTANENUM		9
#define	MAGIC_NONASCII	       10
#define	MAGIC_NOTCRNULLORLF    11
#define	MAGIC_CONSTRING	       12
#define	MAGIC_TOOSMALLSTR      13
#define	MAGIC_TOOBIGSTR	       14
#define	MAGIC_INDFLEN	       15
#define	MAGIC_SENDRESPONSE     16
#define	MAGIC_READONLY	       17
#define	MAGIC_VARVARBINDS      18
#define	MAGIC_VARNAMEBINDS     19
#define	MAGIC_VARVALUEBINDS    20
#define	MAGIC_BERLESUDP	       21
#define	MAGIC_UDPLESBER	       22
#define	MAGIC_SENDGET	       23
#define	MAGIC_SENDNEXT	       24
#define	MAGIC_SENDSET	       25
#define	MAGIC_SENDXXX	       26
#define	MAGIC_BIGCOUNTER       27
#define	MAGIC_ROLLCOUNTER      28
#define	MAGIC_BIGGAUGE	       29
#define	MAGIC_TOOBIG	       30

extern	int	magicommand;
#endif


extern	OID	nullSpecific;


extern	int	quantum;
extern	struct timeval my_boottime;


void	adios (), advise ();
