/* privacy.c - privacy routines */

#ifndef	lint
static char *rcsid = "$Header$";
#endif

/* 
 * $Header$
 *
 *
 * $Log$
 */

/*
 *			4BSD/ISODE SNMPv2 NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions given in the file
 *    SNMPv2-READ-ME.
 *
 */


#include <stdio.h>
#include "objects.h"
#include "party.h"

/*  */

struct qbuf *qb_cpy ();



/*  */

struct qbuf *do_decryption (privmsg, dstParty)
struct type_SNMP_SnmpPrivMsg *privmsg;
struct snmp_party *dstParty;
{
    struct qbuf *qb;

    if (privmsg == NULL) {
	(void) sprintf (PY_pepy, "null privmsg");
	return NULL;
    }
    if (dstParty == NULL) {
	(void) sprintf (PY_pepy, "null dstParty");
	return NULL;
    }

    switch (dstParty -> party_privProt) {
	case BADPRIV:
	    (void) sprintf (PY_pepy,
			    "unable to determine privacy protocol for %s",
			    oid2ode (dstParty -> party_Identity));
	    return NULL;

	case NOPRIV:
	    return qb_cpy (privmsg -> privData);


	default:
	    (void) sprintf (PY_pepy,
			    "no support for privacy protocol (%d) for %s",
			    dstParty -> party_privProt,
			    oid2ode (dstParty -> party_Identity));
	    return NULL;
    }
}

/*  */

int	do_decryption_fixup (privmsg, qb)
struct type_SNMP_SnmpPrivMsg *privmsg;
struct qbuf *qb;
{
    register int    len;

    if (qb != qb -> qb_forw && (len = qb -> qb_forw -> qb_len) > 0) {
	register struct qbuf *pb = privmsg -> privData;

	if (debug)
	    fprintf (stderr, "trim %d octets\n", len);

	pb -> qb_len -= len;
	pb -> qb_forw -> qb_len -= len;
    }
}

/*  */

int	do_encryption (privmsg, dstParty)
struct type_SNMP_SnmpPrivMsg *privmsg;
struct snmp_party *dstParty;
{
    struct qbuf *qb;

    if (privmsg == NULL) {
	(void) sprintf (PY_pepy, "null privmsg");
	return NOTOK;
    }
    if (dstParty == NULL) {
	(void) sprintf (PY_pepy, "null dstParty");
	return NOTOK;
    }

    switch (dstParty -> party_privProt) {
	case BADPRIV:
	    (void) sprintf (PY_pepy,
			    "unable to determine privacy protocol for %s",
			    oid2ode (dstParty -> party_Identity));
	    return NOTOK;

	case NOPRIV:
	    return OK;


	default:
	    (void) sprintf (PY_pepy,
			    "no support for privacy protocol (%d) for %s",
			    dstParty -> party_privProt,
			    oid2ode (dstParty -> party_Identity));
	    return NOTOK;
    }
}

/*  */

static struct qbuf *qb_cpy (cb)
struct qbuf *cb;
{
    register struct qbuf *qb,
			 *pb;

    if (cb -> qb_forw -> qb_forw != cb) {
	(void) sprintf (PY_pepy, "constructed-encoding octet string");
	return NULL;
    }
    cb = cb -> qb_forw;

    if ((pb = (struct qbuf *) malloc ((unsigned) (sizeof *pb + cb -> qb_len)))
		== NULL
	    || (qb = (struct qbuf *) malloc (sizeof *qb)) == NULL) {
	if (pb)
	    free ((char *) pb);
	(void) sprintf (PY_pepy, "out of memory");
	return NULL;
    }
    qb -> qb_forw = qb -> qb_back = qb;
    qb -> qb_data = NULL, qb -> qb_len = cb -> qb_len;
    insque (pb, qb);

    pb -> qb_data = pb -> qb_base;
    if ((pb -> qb_len = cb -> qb_len) > 0)
	bcopy (cb -> qb_data, pb -> qb_data, cb -> qb_len);

    return qb;
}

/*  */

