/* snmp-g.c - SNMP group */

#ifndef	lint
static char *rcsid = "$Header$";
#endif

/* 
 * $Header$
 *
 *
 * $Log$
 */

/*
 *			  ISODE 8.0 NOTICE
 *
 *   Acquisition, use, and distribution of this module and related
 *   materials are subject to the restrictions of a license agreement.
 *   Consult the Preface in the User's Manual for the full terms of
 *   this agreement.
 *
 *
 *			4BSD/ISODE SNMPv2 NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions given in the file
 *    SNMPv2-READ-ME.
 *
 */


#include <stdio.h>
#include "mib.h"
#include "snmp-g.h"

/*    SNMP GROUP */

struct snmpstat snmpstat;

caddr_t	*agentAction;

/*  */

static	integer	snmpORLastChange = 0L;
static	OT	myObjectID = NULL;
static	OT	myDescr = NULL;


#define	orID		1
#define	orDescr		2


/* ARGSUSED */

static int  o_snmp_or (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    register int    i;
    int	    ifvar;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;
    register OS	    os;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem != ot -> ot_name -> oid_nelem + 1
		    || oid -> oid_elements[oid -> oid_nelem - 1] != 1)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		OID	new;

		if ((new = oid_extend (oid, 1)) == NULLOID)
		    return NOTOK;
		new -> oid_elements[new -> oid_nelem - 1] = 1;

		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;
	    }
	    else
		return NOTOK;
	    break;
		
	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case orID:
	    ot = myObjectID;
	    break;

	case orDescr:
	    ot = myDescr;
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    if ((os = ot -> ot_syntax) == NULLOS)
	return (offset == type_SNMP_PDUs_get__next__request ? NOTOK
					: int_SNMP_error__status_genErr);
    if (ot -> ot_info == NULL)
	return (offset == type_SNMP_PDUs_get__next__request ? NOTOK
					: int_SNMP_error__status_noSuchName);

    if (v -> value)
	free_SNMP_ObjectSyntax (v -> value), v -> value = NULL;
    if ((*os -> os_encode) (ot -> ot_info, &v -> value) == NOTOK)
	return (offset == type_SNMP_PDUs_get__next__request ? NOTOK
					: int_SNMP_error__status_genErr);

    return int_SNMP_error__status_noError;
}

/*  */

static struct objreg snmp_objects[] = {
    "snmpInPkts",		(caddr_t) &snmpstat.s_packets,
    "snmpOutPkts",		(caddr_t) &snmpstat.s_outpkts,
    "snmpInBadVersions",	(caddr_t) &snmpstat.s_badversions,
    "snmpInBadCommunityNames",	(caddr_t) &snmpstat.s_badcommunitynames,
    "snmpInBadCommunityUses",	(caddr_t) &snmpstat.s_badcommunityuses,
    "snmpInASNParseErrs",	(caddr_t) &snmpstat.s_encodingerrs,
    "snmpInTooBigs",		(caddr_t) &snmpstat.s_intoobigs,
    "snmpInNoSuchNames",	(caddr_t) &snmpstat.s_innosuchnames,
    "snmpInBadValues",		(caddr_t) &snmpstat.s_inbadvalues,
    "snmpInReadOnlys",		(caddr_t) &snmpstat.s_inreadonlys,
    "snmpInGenErrs",		(caddr_t) &snmpstat.s_ingenerrs,
    "snmpInTotalReqVars",	(caddr_t) &snmpstat.s_totalreqvars,
    "snmpInTotalSetVars",	(caddr_t) &snmpstat.s_totalsetvars,
    "snmpInGetRequests",	(caddr_t) &snmpstat.s_ingetrequests,
    "snmpInGetNexts",		(caddr_t) &snmpstat.s_ingetnexts,
    "snmpInSetRequests",	(caddr_t) &snmpstat.s_insetrequests,
    "snmpInGetResponses",	(caddr_t) &snmpstat.s_ingetresponses,
    "snmpInTraps",		(caddr_t) &snmpstat.s_intraps,
    "snmpOutTooBigs",		(caddr_t) &snmpstat.s_outtoobigs,
    "snmpOutNoSuchNames",	(caddr_t) &snmpstat.s_outnosuchnames,
    "snmpOutBadValues",		(caddr_t) &snmpstat.s_outbadvalues,
    "snmpOutGenErrs",		(caddr_t) &snmpstat.s_outgenerrs,
    "snmpOutGetRequests",	(caddr_t) &snmpstat.s_outgetrequests,
    "snmpOutGetNexts",		(caddr_t) &snmpstat.s_outgetnexts,
    "snmpOutSetRequests",	(caddr_t) &snmpstat.s_outsetrequests,
    "snmpOutGetResponses",	(caddr_t) &snmpstat.s_outgetresponses,
    "snmpOutTraps",		(caddr_t) &snmpstat.s_outtraps,

    NULL
};


static struct objreg snmpV2_objects[] = {
    "snmpStatsPackets",		(caddr_t) &snmpstat.s_packets,
    "snmpStats30Something",	(caddr_t) &snmpstat.s_30something,
    "snmpStatsEncodingErrors",	(caddr_t) &snmpstat.s_encodingerrs,
    "snmpStatsUnknownDstParties",(caddr_t) &snmpstat.s_unknownsrcparties,
    "snmpStatsDstPartyMismatches",(caddr_t) &snmpstat.s_dstpartymismatches,
    "snmpStatsUnknownSrcParties",(caddr_t) &snmpstat.s_unknowndstparties,
    "snmpStatsBadAuths",	(caddr_t) &snmpstat.s_badauths,
    "snmpStatsNotInLifetimes",	(caddr_t) &snmpstat.s_notinlifetimes,
    "snmpStatsWrongDigestValues",(caddr_t) &snmpstat.s_wrongdigestvalues,
    "snmpStatsUnknownContexts",	(caddr_t) &snmpstat.s_unknowncontexts,
    "snmpStatsBadOperations",	(caddr_t) &snmpstat.s_badoperations,
    "snmpStatsSilentDrops",	(caddr_t) &snmpstat.s_silentdrops,

    "snmpV1BadCommunityNames",  (caddr_t) &snmpstat.s_badcommunitynames,
    "snmpV1BadCommunityUses",	(caddr_t) &snmpstat.s_badcommunityuses,

    "snmpORLastChange",		(caddr_t) &snmpORLastChange,

    NULL
};


static struct objreg snmp_or_objects[] = {
    "snmpORID",			(caddr_t) orID,
    "snmpORDescr",		(caddr_t) orDescr,

    NULL
};


extern	int	_agentP;

init_snmp (isnmpV2, isaction)
int	isnmpV2,
	isaction;
{
    bzero ((char *) &snmpstat, sizeof snmpstat);

    _agentP = 1;

    if (isnmpV2) {
	OT	ot;

	if (ot = text2obj ("snmpInBadCommunityNames"))
	    ot -> ot_getfnx = NULLIFP;

	register_objects (snmpV2_objects, o_generic, NULLIFP);
	register_objects (snmp_or_objects, o_snmp_or, NULLIFP);
	if (!(myObjectID = text2obj ("sysObjectID"))) {
	    (void) sprintf (PY_pepy, "text2obj (\"sysObjectID\") failed");
	    return NOTOK;
	}
	if (!(myDescr = text2obj ("sysDescr"))) {
	    (void) sprintf (PY_pepy, "text2obj (\"sysDescr\") failed");
	    return NOTOK;
	}
	if (new_snmp ("snmpV2EnableAuthenTraps", &snmpstat.s_enableauthentraps,
		      TRAPS_ENABLED) == NOTOK)
	    return NOTOK;

	if (new_snmp ("snmpSetSerialNo", (caddr_t **) 0, 0) == NOTOK)
	    return NOTOK;
    }
    else {
	register_objects (snmp_objects, o_generic, NULLIFP);
	if (new_snmp ("snmpEnableAuthenTraps", &snmpstat.s_enableauthentraps,
		      TRAPS_ENABLED) == NOTOK)
	    return NOTOK;
    }

    if (isaction
	    && new_snmp ("agentAction", &agentAction, AGENT_OTHER) == NOTOK)
	return NOTOK;

    return OK;
}

/*  */

static int  new_snmp (text, theval, defval)
char   *text;
caddr_t **theval;
int	defval;
{
    register OT	    ot;
    
    if ((ot = text2obj (text)) == NULL) {
	(void) sprintf (PY_pepy, "unable to resolve %s", text);
	return NOTOK;
    }

    ot -> ot_getfnx = o_generic;
    ot -> ot_setfnx = s_generic;
    if ((ot -> ot_info = calloc (1, sizeof (integer))) == NULL) {
        (void) strcpy (PY_pepy, "out of memory");
        return NOTOK;
    }
    if (theval)
	*theval = &ot -> ot_info;
    *((integer *) ot -> ot_info) = defval;

    return OK;
}
