#!/usr/local/bin/snmptcl -f

if {![info exists snmptcl_loaded(browsing.tcl)]} {
    if {[file readable browsing.tcl]} {
	source			browsing.tcl
    } else {
	source			$snmptcl_library/browsing.tcl
    }
}

if {[info exists snmptcl_loaded(party-browse.tcl)]} {
    return
}
set	snmptcl_loaded(party-browse.tcl)	1


#
# turn on "Applications" menu
#

.title.apps	configure	-state normal
.title.apps.menu \
		add cascade	-label "Party MIB browse" \
				-menu [set menu .title.apps.menu.party]
menu		$menu


#
# Party table
#

$menu		add command	-command {snmptcl_proc_browsetable $snmptcl_agent 1 "Party table for $snmptcl_context" party {
{ partyIndex			"#"			}
{ partyTDomain			TDomain			}
{ partyTAddress			TAddress		}
{ partyMaxMessageSize		MTU			}
{ partyLocal			Local			}
{ partyAuthProtocol		AuthProt		}
{ partyAuthClock		Clock			}
{ partyAuthLifetime		Life			}
{ partyPrivProtocol		PrivProt		}
{ partyCloneFrom		Clone			}
{ partyStorageType		Storage			}
{ partyStatus			Status			}
{ snmpTrapNumbers		Traps		        }
{ iSODEPartyTestMode		Test			}
} 600 {snmptcl_browsetable_command Identity snmptcl_proc_oid2ode}} \
				-label "Party table"

#
# Context table
#

$menu		add command	-command {snmptcl_proc_browsetable $snmptcl_agent 1 "Context table for $snmptcl_context" context {
{ contextIndex			"#"			}
{ iSODEContextName		Name			}
{ contextLocal			Local			}
{ contextViewIndex		"View#"			}
{ contextLocalEntity		LocalEntity		}
{ contextLocalTime		LocalTime		}
{ contextProxyDstParty		ProxyDstParty		}
{ contextProxySrcParty		ProxySrcParty		}
{ contextProxyContext		ProxyContext		}
{ contextStorageType		Storage			}
{ contextStatus			Status			}
} 600 {snmptcl_browsetable_command Identity snmptcl_proc_oid2ode}} \
				-label "Context table"


#
# ACL table
#

$menu		add command	-command {snmptcl_proc_browsetable $snmptcl_agent 1 "ACL table for $snmptcl_context" acl {
{ aclPrivileges			Privileges		}
{ aclStorageType		Storage			}
{ aclStatus			Status			}
} 600 {snmptcl_browsetable_command "s t r" {}}} \
				-label "ACL table"

set	snmptcl_print_object(aclPrivileges)	snmptcl_print_aclPrivileges

proc	snmptcl_print_aclPrivileges {var data}	{
    upvar	$data	info

    set		value		[lindex $info 4]
    set	    	privs		""
    foreach	priv		{ {get 1} {next 2} {response 4} {set 8}
				  {v1trap 16} {bulk 32} {inform 64}
				  {trap 128}} {
	if {[lindex $priv 1] & $value} {
	    lappend	privs	[lindex $priv 0]
	}
    }

    return	"[join $privs {, }] ($value)"
}

#
# View table
#

$menu		add command	-command {snmptcl_proc_browsetable $snmptcl_agent 1 "View table for $snmptcl_context" view {
{ viewMask			Mask			}
{ viewType			Type			}
{ viewStorageType		Storage			}
{ viewStatus			Status			}
} 600 {snmptcl_browsetable_command "# subtree" snmptcl_print_view}} \
				-label "View table"

proc	snmptcl_print_view	{inst}	{
    if {[llength $inst] != 2} {
	return		$inst
    }

    return	"[lindex $inst 0] [snmptcl_proc_oid2ode [lindex $inst 1]]"
}