if {[info exists snmptcl_loaded(BSDUNIX-MIB.tcl)]} {
    return
}
set	snmptcl_loaded(BSDUNIX-MIB.tcl)	1

if {![info exists snmptcl_loaded(SNMPv2-SMI.tcl)]} {
    if {[file readable SNMPv2-SMI.tcl]} {
	source SNMPv2-SMI.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-SMI.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-TC.tcl)]} {
    if {[file readable SNMPv2-TC.tcl]} {
	source SNMPv2-TC.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-TC.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-CONF.tcl)]} {
    if {[file readable SNMPv2-CONF.tcl]} {
	source SNMPv2-CONF.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-CONF.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-PARTY.tcl)]} {
    if {[file readable SNMPv2-PARTY.tcl]} {
	source SNMPv2-PARTY.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-PARTY.tcl }
    }
}

if {![info exists snmptcl_loaded(RFC1213-MIB.tcl)]} {
    if {[file readable RFC1213-MIB.tcl]} {
	source RFC1213-MIB.tcl
    } else {
	catch { source $snmptcl_library/mibs/RFC1213-MIB.tcl }
    }
}

if {![info exists snmptcl_loaded(CLNS-MIB.tcl)]} {
    if {[file readable CLNS-MIB.tcl]} {
	source CLNS-MIB.tcl
    } else {
	catch { source $snmptcl_library/mibs/CLNS-MIB.tcl }
    }
}

if {[catch { snmpinfo mibprop unix value }]} {
    if {[file readable BSDUNIX-MIB.defs]} {
	snmpmisc mibload BSDUNIX-MIB.defs
    } else {
	snmpmisc mibload /usr/include/isode/snmp/BSDUNIX-MIB.defs
    }
}

foreach f {RFC1213-MIB SNMPv2-PARTY-MIB SNMPv2-MIB RFC1354-MIB RFC1414-MIB BSDUNIX-MIB} {
    if {[info exists snmptcl_loaded($f.tcl)]} {
	continue
    }
    if {[file readable $f.tcl]} {
	source $f.tcl
    } else {
	source $snmptcl_library/mibs/$f.tcl
    }
}

snmpmisc agentprop fourBSDisodeAgent supports \
    RFC1213-MIB {system interfaces at ip icmp tcp udp} \
    SNMPv2-PARTY-MIB {partyMIBGroup} \
    SNMPv2-MIB {snmpStatsGroup snmpV1Group snmpORGroup snmpTrapGroup snmpSetGroup} \
    RFC1354-MIB {ipForward} \
    RFC1414-MIB {identInfo} \
    BSDUNIX-MIB {agents mbuf netstat} 
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ifAdminStatus \
    {{SYNTAX {enums 1 2}}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ifOperStatus \
    {{SYNTAX {enums 1 2}}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ifLastChange \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ifInOctets \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ifInNUcastPkts \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ifInDiscards \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ifInUnknownProtos \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ifOutOctets \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ifOutNUcastPkts \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB atEntry \
    {{CREATION-REQUIRES {atPhysAddress}}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipDefaultTTL \
    {{SYNTAX {range 255 255}}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipInAddrErrors \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipInUnknownProtos \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipInDiscards \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipInDelivers \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipOutRequests \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipOutDiscards \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipReasmOKs \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipFragOKs \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipFragFails \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipFragCreates \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipRouteEntry \
    {{CREATION-REQUIRES {ipRouteNextHop}}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipRouteType \
    {{SYNTAX {enums 3 4}} {WRITE-SYNTAX {enums 2 3 4}}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipRouteProto \
    {{SYNTAX {enums 1 4}}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipRouteAge \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipNetToMediaEntry \
    {{CREATION-REQUIRES {ipNetToMediaPhysAddress}}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipNetToMediaType \
    {{SYNTAX {enums 3 4}} {WRITE-SYNTAX {enums 2 3 4}}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB ipRoutingDiscards \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB tcpConnState \
    {{WRITE-SYNTAX {enums 1 2 3 4 5 6 7 8 9 10 11}}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB tcpOutRsts \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB udpInDatagrams \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB udpNoPorts \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1213-MIB udpOutDatagrams \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardNumber \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardDest \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardMask \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardPolicy \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardNextHop \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardIfIndex \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardType \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardProto \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardAge \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardInfo \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardNextHopAS \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardMetric1 \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardMetric2 \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardMetric3 \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardMetric4 \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation RFC1354-MIB ipForwardMetric5 \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation BSDUNIX-MIB mbufFrees \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation BSDUNIX-MIB unixClnpRouteFlags \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation BSDUNIX-MIB unixClnpRouteRefCnt \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDisodeAgent variation BSDUNIX-MIB unixClnpRouteUses \
    {{ACCESS not-implemented}}

foreach f {RFC1213-MIB BSDUNIX-MIB} {
    if {[info exists snmptcl_loaded($f.tcl)]} {
	continue
    }
    if {[file readable $f.tcl]} {
	source $f.tcl
    } else {
	source $snmptcl_library/mibs/$f.tcl
    }
}

snmpmisc agentprop fourBSDunixdPeer supports \
    RFC1213-MIB {system snmp} \
    BSDUNIX-MIB {agents print users unixFs} 
snmpmisc agentprop fourBSDunixdPeer variation BSDUNIX-MIB iSODEContextName \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDunixdPeer variation BSDUNIX-MIB iSODEPartyTestMode \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDunixdPeer variation BSDUNIX-MIB iSODETestIndex \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDunixdPeer variation BSDUNIX-MIB iSODETestInteger \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDunixdPeer variation BSDUNIX-MIB iSODETestString \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDunixdPeer variation BSDUNIX-MIB userQuota \
    {{ACCESS not-implemented}}
snmpmisc agentprop fourBSDunixdPeer variation BSDUNIX-MIB userComment \
    {{ACCESS not-implemented}}
