if {[info exists snmptcl_loaded(SNMPv2-PARTY-MIB.tcl)]} {
    return
}
set	snmptcl_loaded(SNMPv2-PARTY-MIB.tcl)	1

if {![info exists snmptcl_loaded(SNMPv2-SMI.tcl)]} {
    if {[file readable SNMPv2-SMI.tcl]} {
	source SNMPv2-SMI.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-SMI.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-TC.tcl)]} {
    if {[file readable SNMPv2-TC.tcl]} {
	source SNMPv2-TC.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-TC.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-CONF.tcl)]} {
    if {[file readable SNMPv2-CONF.tcl]} {
	source SNMPv2-CONF.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-CONF.tcl }
    }
}

if {[catch { snmpinfo mibprop partyMIB value }]} {
    if {[file readable SNMPv2-PARTY-MIB.defs]} {
	snmpmisc mibload SNMPv2-PARTY-MIB.defs
    } else {
	snmpmisc mibload /usr/include/isode/snmp/SNMPv2-PARTY-MIB.defs
    }
}

snmpmisc mibgroup SNMPv2-PARTY-MIB partyMIBGroup \
    partyIndex \
    partyTDomain \
    partyTAddress \
    partyMaxMessageSize \
    partyLocal \
    partyAuthProtocol \
    partyAuthClock \
    partyAuthPrivate \
    partyAuthPublic \
    partyAuthLifetime \
    partyPrivProtocol \
    partyPrivPrivate \
    partyPrivPublic \
    partyStorageType \
    partyStatus \
    partyCloneFrom \
    contextIndex \
    contextLocal \
    contextViewIndex \
    contextLocalEntity \
    contextLocalTime \
    contextStorageType \
    contextProxyDstParty \
    contextProxySrcParty \
    contextProxyContext \
    contextStatus \
    aclPrivileges \
    aclStorageType \
    aclStatus \
    viewMask \
    viewType \
    viewStorageType \
    viewStatus
