/* misc-snmp.c - additional little things... */

#ifndef	lint
static char *rcsid = "$Header$";
#endif

/*
 * $Header$
 *
 *
 * $Log$
 */

/*			4BSD/ISODE SNMPv2 NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions given in the file
 *    SNMPv2-READ-ME.
 *
 */


#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <strings.h>
#include <varargs.h>
#include <sys/file.h>
#include <tk.h>


#define	NOTOK	(-1)
#define	NULLCP	((char *) 0)


char   *malloc ();

/*    ENTRY */

int	SNMPoidcmp (), SNMPoidcontains ();
int	AfterCommand (), CancelCommand ();


/*    ENTRY */

int	MISC_Init (interp)
Tcl_Interp *interp;
{
/* defined in C for speed (ha!) */
    Tcl_CreateCommand (interp, "snmptcl_proc_oidcmp", SNMPoidcmp,
		       (ClientData) 0, (void (*) ()) 0);
    Tcl_CreateCommand (interp, "snmptcl_proc_oidcontains", SNMPoidcontains,
		       (ClientData) 0, (void (*) ()) 0);

/* new version allowing cancellation */
    Tcl_CreateCommand (interp, "after", AfterCommand, (ClientData) 0,
		       (void (*) ()) 0);
    Tcl_CreateCommand (interp, "cancel", CancelCommand, (ClientData) 0,
		       (void (*) ()) 0);

    return TCL_OK;
}

/*  */

/* this routine is usually invoked from the inner-loop of a callback.
   although you could code it in Tcl, or in C using str2oid, or in C using
   index and strncmp, it's done with inline C...
 */

/* ARGSUSED */

static int  SNMPoidcmp (clientData, interp, argc, argv)
ClientData	clientData;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    int	    result;
    register char  *a,
		   *b;
    char    buffer[BUFSIZ];

    if (argc != 3) {
	(void) sprintf (buffer, "argc=%d; expecting 3", argc);
	goto tcl_error;
    }
    a = argv[1], b = argv[2];

    for (;;) {
	int	    al,
		    bl;
	register char  *ae,
		       *ap,
		       *be;

	for (ae = a; *ae != '.'; ae++)
	    if (!*ae)
		break;
	al = ae - a;

	for (be = b; *be != '.'; be++)
	    if (!*be)
		break;
	bl = be - b;

	if (result = al - bl)
	    goto set_result;

	for (ap = a + al + 1; a < ap; )
	    if (result = *a++ - *b++)
		goto set_result;

	if (!*(a = ae)) {
	    result = *be ? -1 : 0;
	    goto set_result;
	}
	a++;

	if (!*(b = be)) {
	    result = 1;
	    goto set_result;
	}
	b++;
    }

set_result: ;
    Tcl_SetResult (interp, result < 0 ? "-1" : result > 0 ? "1" : "0",
		   TCL_STATIC);
    return TCL_OK;

tcl_error: ;
    Tcl_SetResult (interp, buffer, TCL_VOLATILE);
    return TCL_ERROR;
}

/*  */

/* ARGSUSED */

static int  SNMPoidcontains (clientData, interp, argc, argv)
ClientData	clientData;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    int	    len,
	    result;
    char   *a,
	   *b,
	    buffer[BUFSIZ];

    if (argc != 3) {
	(void) sprintf (buffer, "argc=%d; expecting 3", argc);
	goto tcl_error;
    }

    result = (len = strlen (a = argv[1])) <= strlen (b = argv[2])
		&& !strncmp (a, b, len);

    Tcl_SetResult (interp, result ? "1" : "0", TCL_STATIC);
    return TCL_OK;

tcl_error: ;
    Tcl_SetResult (interp, buffer, TCL_VOLATILE);
    return TCL_ERROR;
}

/*  */

typedef struct afterinfo {
    Tcl_Interp	*interp;
    char	*command;

    u_long	 token;
    struct afterinfo *next;
}	AfterInfo;

static	struct afterinfo *AHead = NULL;

void	AfterTimer ();
int	CancelAux ();


/* ARGSUSED */

static int  AfterCommand (clientData, interp, argc, argv)
ClientData	clientData;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    int	    ms;
    char    buffer[BUFSIZ];
    AfterInfo *afterPtr;

    if (argc < 2) {
	Tcl_AppendResult(interp, "wrong # args: should be \"",
		argv[0], " milliseconds ?command? ?arg arg ...?\"",
		(char *) NULL);
	return TCL_ERROR;
    }

    if (Tcl_GetInt(interp, argv[1], &ms) != TCL_OK) {
	Tcl_AppendResult(interp, "bad milliseconds value \"",
		argv[1], "\"", (char *) NULL);
	return TCL_ERROR;
    }
    if (ms < 0) {
	ms = 0;
    }
    if (argc == 2) {
	Tk_Sleep(ms);
	return TCL_OK;
    }
    afterPtr = (AfterInfo *) ckalloc((unsigned) (sizeof(AfterInfo)));
    afterPtr->interp = interp;
    if (argc == 3) {
	afterPtr->command = (char *) ckalloc((unsigned) (strlen(argv[2]) + 1));
	(void) strcpy(afterPtr->command, argv[2]);
    } else {
	afterPtr->command = Tcl_Concat(argc-2, argv+2);
    }

/* here's the difference... */
    afterPtr -> token = (u_long) Tk_CreateTimerHandler (ms, AfterTimer,
							(ClientData) afterPtr);
    afterPtr -> next = AHead;
    AHead = afterPtr;

    (void) sprintf (buffer, "%U", afterPtr -> token);
    Tcl_SetResult (interp, buffer, TCL_VOLATILE);
/* end difference */

    return TCL_OK;
}

static void  AfterTimer (clientData)
ClientData	clientData;
{
    AfterInfo *afterPtr = (AfterInfo *) clientData;
    int result;

/* here's the difference... */
    register struct afterinfo **ap;
    for (ap = &AHead; *ap != afterPtr; ap = &((*ap) -> next))
	continue;
    *ap = afterPtr -> next;
/* end difference */

    if (afterPtr->command != NULL) {
	result = Tcl_GlobalEval(afterPtr->interp, afterPtr->command);
	if (result != TCL_OK) {
	    Tk_BackgroundError(afterPtr->interp);
	}
	ckfree(afterPtr->command);
    }
    ckfree((char *) afterPtr);
}


/* ARGSUSED */

static int  CancelCommand (clientData, interp, argc, argv)
ClientData	clientData;
Tcl_Interp     *interp;
int		argc;
char	      **argv;
{
    u_long	afterID;
    register struct afterinfo *ap;

    if (argc < 2) {
	while (AHead)
	    if (CancelAux (interp, AHead, 0) == TCL_ERROR)
		return TCL_ERROR;

	return TCL_OK;
    }
    if (argc > 2) {
	Tcl_AppendResult (interp, "wrong # args: should be \"",
			  argv[0], " ?afterID?\"", NULLCP);
	return TCL_ERROR;
    }
    if (sscanf (argv[1], "%U", &afterID) != 1) {
bad_afterID: ;
	Tcl_AppendResult (interp, "bad afterID value \"", argv[1], "\"",
			  NULLCP);
	return TCL_ERROR;
    }
    for (ap = AHead; ap; ap = ap -> next)
	if (ap -> token == afterID)
	    break;
    if (!ap)
	goto bad_afterID;
    return CancelAux (interp, ap, 1);
}


/* ARGSUSED */

static int  CancelAux (interp, afterPtr, wantcmd)
Tcl_Interp     *interp;
struct afterinfo *afterPtr;
int	wantcmd;
{
    register struct afterinfo **ap;

    for (ap = &AHead; *ap != afterPtr; ap = &((*ap) -> next))
	continue;
    *ap = afterPtr -> next;

    Tk_DeleteTimerHandler ((Tk_TimerToken) afterPtr -> token);
    if (afterPtr -> command)
	if (wantcmd)
	    Tcl_SetResult (interp, afterPtr -> command, TCL_DYNAMIC);
	else
	    ckfree (afterPtr -> command);
    ckfree ((char *) afterPtr);

    return TCL_OK;
}
