: run this script through /bin/sh

A="$1"
case "$#" in
    2)	C="$A/$2"
	;;

    3)	D=/tmp/test$$
	P=$D/party
	trap "rm -rf $D" 0 1 2 3 13 15

	C="-party $P $A"
	X="0.161"

	mkdir	   $D
	chmod 0700 $D
	touch      $P.public $P.private $P.context $P.access
	chmod 0600 $P.public $P.private $P.context $P.access
echo \
"L initialPartyId.$A.1 \\
	snmpUDPDomain 0x$A.$X 484 \\
	noAuth 0 0 \\
	noPriv

M initialPartyId.$A.2 \\
	snmpUDPDomain 0x0.0.0.0.0.0 8192 \\
	noAuth 0 0 \\
	noPriv

L initialPartyId.$A.3 \\
	snmpUDPDomain 0x$A.$X 484 \\
	v2md5AuthProtocol 0 300 \\
	noPriv

M initialPartyId.$A.4 \\
	snmpUDPDomain 0x0.0.0.0.0.0 8192 \\
	v2md5AuthProtocol 0 300 \\
	noPriv" \
> $P.public

echo \
"initialPartyId.$A.1 active
initialPartyId.$A.2 active

initialPartyId.$A.3 active	\"$2\"
initialPartyId.$A.4 active	\"$3\"" \
> $P.private

echo \
"A initialContextId.$A.1 \"$A-system\"   active \\
	view 1 \"\" currentTime
A initialContextId.$A.2 \"$A-internet\" active \\
	view 2 \"\" currentTime" \
> $P.context

echo \
"initialPartyId.$A.1 \\
	initialPartyId.$A.2 \\
	initialContextId.$A.1 \\
	active get get-next get-bulk
initialPartyId.$A.2 \\
	initialPartyId.$A.1 \\
	initialContextId.$A.1 \\
	active response

initialPartyId.$A.3 \\
	initialPartyId.$A.4 \\
	initialContextId.$A.2 \\
	active get get-next set get-bulk
initialPartyId.$A.4 \\
	initialPartyId.$A.3 \\
	initialContextId.$A.2 \\
	active response" \
>$P.access
	;;

    *)	echo "usage: test-agent.sh IP-address [ community | key1 key2 ]" \
							1>&2
	exit 1
	;;
esac

if echo "$A" | awk '
/^[1-9][0-9]*\.[1-9][0-9]*\.[1-9][0-9]*\.[1-9][0-9]*$/ { next; }
	{ exit(1); }
'; then
    true
else
    echo "invalid IP-address: $A"			1>&2
    echo "usage: test-agent.sh IP-address ..."		1>&2
    exit 1
fi

for M in [A-Z]*.my; do
    if [ ! -s $M ]; then
	continue
    fi

    D=`dirname $M`/`basename $M .my`.defs
    if [ -s $D ]; then
	G="`find $D -newer $M -print`"
    else
	G=
    fi

    if [ -z "$G" ]; then
	echo -n "compiling $M... "
	if run-compile.sh $M >/dev/null 2>&1; then
	    echo "done"
	else
	    echo "failed, run \"run-compile.sh $M\""	1>&2
	    exit 1
	fi
    fi
done

snmptcl -file /usr/local/etc/snmptcl/testing.tcl -noupdate $C
